Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 256 by niro, Mon Oct 3 21:02:31 2005 UTC branches/mage-next/src/smage2.in revision 2631 by niro, Mon Mar 10 12:15:30 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.39 2005-10-03 21:02:31 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default variables
11  PKGSUFFIX="mpk"  : ${MAGERC="@@SYSCONFDIR@@/mage.rc"}
12  SMAGENAME="$1"  : ${MLIBDIR="@@MAGELIBDIR@@"}
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
13    
14  # export default C locale  # export default C locale
15  export LC_ALL=C  export LC_ALL=C
16    
17  source /etc/mage.rc  # first of all include common functions
18    source ${MLIBDIR}/common.functions.sh || exit 1
19  showversion() {  source @@SYSCONFDIR@@/mage.rc.global || die "@@SYSCONFDIR@@/mage.rc.global missing."
20   echo -en "Magellan Source Install v${SMAGEVERSION} "  source ${MAGERC} || die "${MAGERC} missing."
21   echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  source ${MLIBDIR}/mage4.functions.sh || die "${MLIBDIR}/mage4.functions.sh missing."
22  }  source ${MLIBDIR}/smage2.functions.sh || die "${MLIBDIR}/smage2.functions.sh missing."
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
23    
24   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  # export default path
25    export PATH="${PATH}:${MLIBDIR}"
26    
27   local EOA=${#SRC_URI[*]}  print_usage()
28   local my_SRC_URI  {
29   local my_SRC_URI_DEST   echo "Usage: $(basename $0) [option] pkgname ..."
30   local my_SRC_URI_MIRROR   echo "Options:"
31   local my_SOURCEDIR   echo "--smage"
32   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   echo "--src-tarball"
33   local FETCHING   echo "--calc"
34   local i mirror   echo "--update"
35     echo "--download"
36     echo "--regen"
37   #install SRCDIR/PNAME if not exist   echo "--create-src-tarball"
38   [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}   echo "--resume"
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
 # only needed to run through a list of mirrors  
 # if [ "$?" == "0" ]  
 # then  
 # break  
 # else  
 # continue  
 # fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
   
  # recheck md5 sums  
39   echo   echo
40   echo ">== Checking MD5 sums:"   echo "Environment variables::"
41   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   echo " NOCOLORS=true $(basename $0) [src]install PACKAGE"
42     echo " Disables all colors in the messages."
43   echo   echo
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall() {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
44  }  }
45    
46  mmake() {  # very basic getops
47   make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  for i in $*
48  }  do
49     case $1 in
50  munpack() {   --smage|*.${SMAGESUFFIX}) shift; SMAGENAME="$1" ;;
51   local SRCFILE   --src-tarball) shift; SRCPKGTARBALL="$1" ;;
52   local IFTAR   --calc) shift; SMAGENAME="$1" ;;
53   local DEST   --update) ;;
54     --download) shift; SMAGENAME="$1" ;;
55   SRCFILE=$1   --regen) shift; SMAGENAME="$1" ;;
56     --create-src-tarball) shift; SMAGENAME="$1" ;;
57   if [ -z "$2" ]   --resume) ;;
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
58   esac   esac
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 sminclude() {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment(){  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Using CCache for compilation ..."  
  export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  #unset CC CXX  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps() {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions wich should also be added  
 #                         warning: they get killed before the build starts !  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [ -n "$1" ] && target="-$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo "Generating Mage file:"  
  echo "  ${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.39 2005-10-03 21:02:31 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  echo  >> ${dest}  
  fi  
  echo >> ${dest}  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
  echo >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  echo >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  echo  >> ${dest}  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f postinstall >> ${dest}  
  echo  >> ${dest}  
  typeset -f preremove >> ${dest}  
  echo  >> ${dest}  
  typeset -f postremove >> ${dest}  
  echo  >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local i  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [ -z "${MAGE_TARGETS}" ]  
  then  
  echo  
  build_mage_script  
  echo  
  else  
   
  # build for each target an mage file  
  # run it with several targets  
  for i in ${MAGE_TARGETS}  
  do  
  echo  
  build_mage_script "${i}"  
  echo  
  done  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  unset "${i}"  
  done  
  unset SPECIAL_FUNCTIONS  
  for i in ${SPECIAL_VARS}  
  do  
  unset "${i}"  
  done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 export_inherits()  
 {  
  local include="$1"  
59   shift   shift
60    done
61    
62   while [ "$1" ]  ## setup ##
63   do  SMAGENAME="$1"
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -n "Generating a md5sum for ${pkgname}.${PKGSUFFIX} ... "  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo "! exists"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
64    
65   # setup md5 dir  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
66   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"  if [[ -n ${MROOT} ]]
67   install -d ${dest}  then
68     export PKGDIR=${MROOT}/${PKGDIR}
69   # gen md5sum   export BUILDDIR=${MROOT}/${BUILDDIR}
70   ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \   export BINDIR=${MROOT}/${BINDIR}
71   > ${dest}/${pkgname}.md5  fi
  echo "done"  
  fi  
 }  
72    
73  # print out our version  # print out our version
74  showversion  showversion
75  echo  echo
76    
77  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
78  then  then
79   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
80   echo   echo
81   exit 1   exit 1
82  fi  fi
83    
84    # load supported mage features
85    load_mage_features
86    
87  # updating smage2-scripts  # updating smage2-scripts
88  if [ "$1" == "update" ]  if [[ $1 = update ]]
89  then  then
90   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
91   then   then
# Line 757  then Line 96  then
96  fi  fi
97    
98  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
99  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
100  then  then
101   if [ $# -ge 3 ]   if [ $# -ge 2 ]
102   then   then
103   SMAGENAME="$2"   SMAGENAME="$2"
104   MD5DIR="$3"   MD5DIR="$3"
105   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
106    
107     smagesource ${SMAGENAME} || die "download source failed"
108    
109   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
110   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 809  then Line 150  then
150   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
151   unset my_SOURCEDIR   unset my_SOURCEDIR
152   done   done
153    
154   echo   echo
155   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
156   echo   echo
157   else   else
158   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
159   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
160   echo   echo
161   echo   echo
162   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
163   echo   echo
164   exit 1   exit 1
165   fi   fi
166    
167   exit 0   exit 0
168  fi  fi
169    
# Line 837  then Line 178  then
178   # get smage   # get smage
179   SMAGENAME="$2"   SMAGENAME="$2"
180   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
181   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
182    
183   download_sources   download_sources
184   exit 0   exit 0
# Line 849  then Line 190  then
190   # set correct SMAGENAME   # set correct SMAGENAME
191   SMAGENAME="$2"   SMAGENAME="$2"
192   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
193   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
194    
195   regen_mage_tree   regen_mage_tree
196    
197   # build md5sum for existing packages   # build several subpackages
198   generate_package_md5sum \   if [[ -n ${SPLIT_PACKAGES} ]]
199   --pcat "${PCATEGORIE}" \   then
200   --pname "${PNAME}" \   split_save_variables
201   --pver "${PVER}" \   for subpackage in ${SPLIT_PACKAGES}
202   --pbuild "${PBUILD}" \   do
203   --parch "${ARCH}" \   # get the right variables for the split
204   --target "${target}"   export PNAME="${subpackage}"
205     split_info_${subpackage}
206     # fix PCATEGORIE -> PCAT
207     if [[ ! -z ${PCATEGORIE} ]]
208     then
209     PCAT="${PCATEGORIE}"
210     unset PCATEGORIE
211     fi
212     # build md5sum for existing packages
213     generate_package_md5sum \
214     --pcat "${PCAT}" \
215     --pname "${PNAME}" \
216     --pver "${PVER}" \
217     --pbuild "${PBUILD}" \
218     --parch "${ARCH}"
219     # restore smage environment
220     split_restore_variables
221     done
222     # unset all saved smage variables
223     split_unset_variables
224    
225     else
226     # build md5sum for existing packages
227     generate_package_md5sum \
228     --pcat "${PCAT}" \
229     --pname "${PNAME}" \
230     --pver "${PVER}" \
231     --pbuild "${PBUILD}" \
232     --parch "${ARCH}"
233     fi
234    
235   exit 0   exit 0
236  fi  fi
237    
238  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
239  then  then
240   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
241  fi   SMAGENAME="$2"
242     MD5DIR="$(dirname ${SMAGENAME})/md5"
243    
244  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
245    
246  if [ -z "${SOURCEDIR}" ]   smagesource ${SMAGENAME} || die "regen: smage2 not found"
 then  
  die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  
 fi  
247    
248  if [ -z "${SMAGESCRIPTSDIR}" ]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
249  then   then
250   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
251  fi   rm -rf ${SOURCEDIR}/${PKGNAME}
252     fi
253    
254  if [ -z "${SMAGE2RSYNC}" ]   download_sources
255  then   source_pkg_build ${SMAGENAME}
256   echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."   exit 0
  exit 1  
257  fi  fi
258    
259  if [ -z "${BINDIR}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
260  then  then
261   die "no BINDIR variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
262  fi   msetfeature "srcpkgtarball"
263    
264  if [ -z "${CHOST}" ]   # abort if given file is not a source pkg
265  then   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
  die "no CHOST variable found in /etc/mage.rc"  
 fi  
266    
267  if [ -z "${CFLAGS}" ]   # set correct SMAGENAME; use the one that the src_pkg provide
268  then   # /path/to/SOURCEDIR/PNAME/SMAGENAME
269   die "no CFLAGS variable found in /etc/mage.rc"   SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
270    
271     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
272    
273     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
274    
275     # unpack srctarball
276     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
277    
278     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
279    
280     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
281  fi  fi
282    
283  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
284  then  then
285   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
286     SMAGENAME="$2"
287  fi  fi
288    
289    [ ! -e ${MLIBDIR}/pkgbuild_dir ] && die "Error: ${MLIBDIR}/pkgbuild_dir not found. Aborting."
290    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
291     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
292    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
293    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
294    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
295    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
296    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
297    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
298    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
299    
300  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
301  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
302  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
303    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
304    
305  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
306  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
307    
308  # auto regen mage tree if requested  if mqueryfeature "srcpkgbuild"
309  regen_mage_tree  then
310     if [[ -d ${SOURCEDIR}/${PNAME} ]]
311     then
312     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
313     rm -rf ${SOURCEDIR}/${PNAME}
314     fi
315    fi
316    
317  # download sources  # download sources
318  download_sources  mqueryfeature "srcpkgtarball" || download_sources
319    
320  # fixes some issues with these functions  # fixes some issues with these functions
321  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
322  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
323    export -f src_check || die "src_check export failed"
324  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
325    
326  # fixes some compile issues  # fixes some compile issues
327  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
328  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
329  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
330    then
331     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
332    else
333     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
334    fi
335    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
336  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
337  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
338    
   
339  # setup distcc  # setup distcc
340  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
341  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "distcc" && setup_distcc_environment
342  then  
343   setup_distcc_environment  # setup icecc
344  fi  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
345    mqueryfeature "icecc" && setup_icecc_environment
346    
347  # setup ccache  # setup ccache
348  if [ "${SMAGE_USE_CCACHE}" == "true" ]  mqueryfeature "ccache" && setup_ccache_environment
349    
350    if mqueryfeature "resume"
351  then  then
352   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
353  fi  
354     # setup build logging
355     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
356     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
357     then
358     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
359     fi
360     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
361    
362    else
363     # clean up builddir if a previously one exist
364     if [ -d ${BUILDDIR} ]
365     then
366     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
367     fi
368     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
369    
370     # clean up srcdir if a previously unpacked one exist
371     if [ -d ${SRCDIR} ]
372     then
373     rm -rf ${SRCDIR}
374     fi
375    
376  # small sleep to show our settings   # clean up bindir if a previous build exist or create a new one
377  sleep 1   if [ -d ${BINDIR} ]
378     then
379     rm -rf ${BINDIR}
380     fi
381     install -d ${BINDIR} || die "couldn't create \$BINDIR."
382    
383  #debug   # clean up package temp dir if a previous build exist
384  #echo "CC=${CC}"   if [ -d ${BUILDDIR}/${PKGNAME} ]
385  #echo "CXX=${CXX}"   then
386  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${BUILDDIR}/${PKGNAME}
387  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
388    
389  # cleans up build if a previously one exists   # clean up stamps dir
390  if [ -d ${BUILDDIR} ]   if [ -d ${BUILDDIR}/.stamps ]
391  then   then
392   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/.stamps
393     fi
394    
395     # setup build logging
396     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
397     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
398  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
399    
400  # cleans up srcdir if a previously unpacked one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${SRCDIR} ]  
401  then  then
402   rm -rf ${SRCDIR}   echo "virtual package detected; nothing will be build ..."
403     # automatically set !pkgbuild here too
404     msetfeature "!pkgbuild"
405    else
406     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
407     die_pipestatus 0 "src_prepare failed"
408     resume_stamp src_prepare
409     step_by_step src_prepare
410    
411     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
412     die_pipestatus 0 "src_compile failed"
413     resume_stamp src_compile
414     step_by_step src_compile
415    
416     # only run checks if requested
417     if mqueryfeature "!check"
418     then
419     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
420     else
421     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
422     die_pipestatus 0 "src_check failed"
423     resume_stamp src_check
424     fi
425     step_by_step src_check
426    
427     # build several subpackages
428     if [[ -n ${SPLIT_PACKAGES} ]]
429     then
430     # save bindir & pname
431     split_save_variables
432     export SAVED_BINDIR="${BINDIR}"
433     for subpackage in ${SPLIT_PACKAGES}
434     do
435     split_info_${subpackage}
436     if [[ ${PKGTYPE} = virtual ]]
437     then
438     echo
439     echo -en "${COLBLUE}*** ${COLDEFAULT}"
440     echo -en "Virtual package detected"
441     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
442     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
443    
444     echo "virtual package detected; nothing will be build ..."
445     # automatically set !pkgbuild here too
446     msetfeature "!pkgbuild"
447     else
448     if typeset -f src_install_${subpackage} > /dev/null
449     then
450     # export subpackage bindir
451     export BINDIR="${SAVED_BINDIR}_${subpackage}"
452     # export PNAME, several internal function and include
453     # rely on this variable
454     export PNAME="${subpackage}"
455    
456     echo
457     echo -en "${COLBLUE}*** ${COLDEFAULT}"
458     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
459     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
460     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
461    
462     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
463     die_pipestatus 0 "src_install_${subpackage} failed"
464     resume_stamp src_install_${subpackage}
465     step_by_step src_install_${subpackage}
466     fi
467     fi
468     # restore smage environment
469     split_restore_variables
470     done
471     # unset all saved smage variables
472     split_unset_variables
473     else
474     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
475     die_pipestatus 0 "src_install failed"
476     resume_stamp src_install
477     step_by_step src_install
478     fi
479  fi  fi
480    
481  # cleans up bindir if a previous build exists or creates a new one  # echo for sake of good-looking
482  if [ -d ${BINDIR} ]  echo
483    
484    if mqueryfeature "!compressdoc"
485    then
486     echo -e "!compressdoc detected; documentation will not be compressed ..."
487    elif mqueryfeature "!pkgbuild"
488  then  then
489   rm -rf ${BINDIR}   echo "!pkgbuild detected; skipping documentation compression..."
490    else
491     # compressing doc, info & man files
492     if [[ -n ${SPLIT_PACKAGES} ]]
493     then
494     # save smage environment
495     split_save_variables
496     for subpackage in ${SPLIT_PACKAGES}
497     do
498     # honor split_info
499     split_info_${subpackage}
500     if [[ ${PKGTYPE} = virtual ]]
501     then
502     # automatically set !pkgbuild here too
503     msetfeature "!pkgbuild"
504     fi
505    
506     if mqueryfeature "!compressdoc"
507     then
508     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
509     elif mqueryfeature "!pkgbuild"
510     then
511     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
512     else
513     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
514     resume_stamp post-mcompressdoc_${subpackage}
515     fi
516     # restore smage environment
517     split_restore_variables
518     done
519     # unset saved variables
520     split_unset_variables
521     else
522     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
523     resume_stamp post-mcompressdoc
524     fi
525  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
526    
527  # cleans up package temp dir if a previous build exists  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
528  then  then
529   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
530     then
531     echo "!pkgbuild detected; skipping libtool archive stripping ..."
532     else
533     if [[ -n ${SPLIT_PACKAGES} ]]
534     then
535     # save smage environment
536     split_save_variables
537     for subpackage in ${SPLIT_PACKAGES}
538     do
539     # honor split_info
540     split_info_${subpackage}
541     if [[ ${PKGTYPE} = virtual ]]
542     then
543     # automatically set !pkgbuild here too
544     msetfeature "!pkgbuild"
545     fi
546    
547     if mqueryfeature "!libtool"
548     then
549     if mqueryfeature "!pkgbuild"
550     then
551     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
552     else
553     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
554     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
555     resume_stamp post-mstriplibtoolarchive_${subpackage}
556     fi
557     fi
558    
559     # restore smage environment
560     split_restore_variables
561     done
562     # unset saved variables
563     split_unset_variables
564     else
565     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
566     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
567     resume_stamp post-mstriplibtoolarchive
568     fi
569     fi
570  fi  fi
571    
572  # cleans up timestamp if one exists  if mqueryfeature "purge"
 if [ -f /var/tmp/timestamp ]  
573  then  then
574   mage rmstamp   if mqueryfeature "!pkgbuild"
575  fi   then
576     echo "!pkgbuild detected; skipping file purgation ..."
577     else
578     if [[ -n ${SPLIT_PACKAGES} ]]
579     then
580     # save smage environment
581     split_save_variables
582     for subpackage in ${SPLIT_PACKAGES}
583     do
584     # honor split_info
585     split_info_${subpackage}
586     if [[ ${PKGTYPE} = virtual ]]
587     then
588     # automatically set !pkgbuild here too
589     msetfeature "!pkgbuild"
590     fi
591    
592  src_prepare || die "src_prepare failed"   if mqueryfeature "purge"
593  src_compile || die "src_compile failed"   then
594  src_install || die "src_install failed"   if mqueryfeature "!pkgbuild"
595     then
596     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
597     else
598     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
599     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
600     resume_stamp post-mpurgetargets_${subpackage}
601     fi
602     fi
603    
604     # restore smage environment
605     split_restore_variables
606     done
607     # unset saved variables
608     split_unset_variables
609     else
610     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
611     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
612     resume_stamp post-mpurgetargets
613     fi
614     fi
615    fi
616    
617  # compressing doc, info & man files  # stripping all bins and libs
618  echo -e "Compressing man-pages ..."  if mqueryfeature "!strip"
619  if [ -d ${BUILDDIR}/builded/usr/share/man ]  then
620     echo -e "!strip detected; package will not be stripped ..."
621    elif mqueryfeature "!pkgbuild"
622  then  then
623   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   echo "!pkgbuild detected; skipping stripping of the package ..."
624    else
625     if [[ -n ${SPLIT_PACKAGES} ]]
626     then
627     # save smage environment
628     split_save_variables
629     for subpackage in ${SPLIT_PACKAGES}
630     do
631     # honor split_info
632     split_info_${subpackage}
633     if [[ ${PKGTYPE} = virtual ]]
634     then
635     # automatically set !pkgbuild here too
636     msetfeature "!pkgbuild"
637     fi
638    
639     if mqueryfeature "!strip"
640     then
641     echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
642     elif mqueryfeature "!pkgbuild"
643     then
644     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
645     else
646     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
647     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
648     resume_stamp post-mstripbins_${subpackage}
649     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
650     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
651     resume_stamp post-mstriplibs_${subpackage}
652     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
653     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
654     resume_stamp post-mstripstatic_${subpackage}
655     fi
656    
657     # restore smage environment
658     split_restore_variables
659     done
660     # unset saved variables
661     split_unset_variables
662     else
663     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
664     run_resume post-mstripbins || mstripbins ${BINDIR}
665     resume_stamp post-mstripbins
666     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
667     run_resume post-mstriplibs || mstriplibs ${BINDIR}
668     resume_stamp post-mstriplibs
669     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
670     run_resume post-mstripstatic || mstripstatic ${BINDIR}
671     resume_stamp post-mstripstatic
672     fi
673  fi  fi
674    
675  echo -e "Compressing info-pages ..."  if mqueryfeature "qalint"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
676  then  then
677   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   if mqueryfeature "!pkgbuild"
678     then
679     echo "!pkgbuild detected; skipping QA lint checks ..."
680     else
681     if [[ -n ${SPLIT_PACKAGES} ]]
682     then
683     # save smage environment
684     split_save_variables
685     for subpackage in ${SPLIT_PACKAGES}
686     do
687     # honor split_info
688     split_info_${subpackage}
689     if [[ ${PKGTYPE} = virtual ]]
690     then
691     # automatically set !pkgbuild here too
692     msetfeature "!pkgbuild"
693     fi
694    
695     if mqueryfeature "qalint"
696     then
697     if mqueryfeature "!pkgbuild"
698     then
699     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
700     else
701     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
702     mqalint ${BINDIR}_${subpackage}
703     fi
704     fi
705    
706     # restore smage environment
707     split_restore_variables
708     done
709     # unset saved variables
710     split_unset_variables
711     else
712     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
713     mqalint ${BINDIR}
714     fi
715     fi
716  fi  fi
717    
718  # stripping all bins and libs  if mqueryfeature "!pkgbuild"
719  case ${NOSTRIP} in  then
720   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
721   echo -e "NOSTRIP=true detected; Package will not be stripped ..."  else
722   ;;   # build several subpackages
723   *)   if [[ -n ${SPLIT_PACKAGES} ]]
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 # the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  # build serveral targets  
  if [ -n "${MAGE_TARGETS}" ]  
724   then   then
725   for target in ${MAGE_TARGETS}   split_save_variables
726     for subpackage in ${SPLIT_PACKAGES}
727   do   do
728   # check if an special target_pkgbuild exists   # get the right variables for the split
729   if typeset -f ${target}_pkgbuild > /dev/null   export PNAME="${subpackage}"
730     split_info_${PNAME}
731     # fix PCATEGORIE -> PCAT
732     if [[ ! -z ${PCATEGORIE} ]]
733     then
734     PCAT="${PCATEGORIE}"
735     unset PCATEGORIE
736     fi
737     if [[ ${PKGTYPE} = virtual ]]
738     then
739     # automatically set !pkgbuild here too
740     msetfeature "!pkgbuild"
741     fi
742    
743     # jump to next one if !pkgbuild is set in split_info
744     if mqueryfeature "!pkgbuild"
745     then
746     # restore smage environment
747     split_restore_variables
748     continue
749     fi
750    
751     # check if an special subpackage_pkgbuild exists
752     if typeset -f ${PNAME}_pkgbuild > /dev/null
753   then   then
754   # run it   # run it
755   ${target}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
756     resume_stamp post-${PNAME}_pkgbuild
757   fi   fi
758   # now create the target package   # now create the target package
759   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir \
760   "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
761   ${BINDIR} || die "target: ${target} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
762     resume_stamp post-pkg_builddir_${PNAME}
763    
764   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
765   generate_package_md5sum \   run_resume post-md5sum_${PNAME} || generate_package_md5sum \
766   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
767   --pname "${PNAME}" \   --pname "${PNAME}" \
768   --pver "${PVER}" \   --pver "${PVER}" \
769   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
770   --parch "${ARCH}" \   --parch "${ARCH}"
771   --target "${target}"   resume_stamp post-md5sum_${PNAME}
772    
773     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
774    
775   echo -e "\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n"   # restore smage environment
776     split_restore_variables
777   done   done
778     # unset all saved smage variables
779     split_unset_variables
780    
781   else   else
782   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir ${PKGNAME} ${BINDIR} || die "package-build failed"
783     resume_stamp post-pkg_builddir
784    
785   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
786   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
787   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
788   --pname "${PNAME}" \   --pname "${PNAME}" \
789   --pver "${PVER}" \   --pver "${PVER}" \
790   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
791   --parch "${ARCH}"   --parch "${ARCH}"
792     resume_stamp post-md5sum
793    
794     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
795     fi
796    
797   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   # build src-pkg-tarball if requested
798     if mqueryfeature "srcpkgbuild"
799     then
800     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
801     resume_stamp post-srcpkgbuild
802   fi   fi
803   ;;  fi
804  esac  
805    # auto regen mage tree if requested
806    regen_mage_tree
807    
808    if mqueryfeature "buildlog"
809    then
810     bzip2 -9f /var/log/smage/${PKGNAME}.log
811    else
812     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
813    fi
814    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
815  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.256  
changed lines
  Added in v.2631